// Characters_Strings
// by REAS <http://www.groupc.net>

// Click on the image to give it focus and then type letters to
// shift the location of the image.
// Characters are typographic symbols such as A, d, and %. 
// The character datatype, abbreviated as char, stores letters and 
// symbols in the Unicode format, a coding system developed to support 
// a variety of world languages. Characters are distinguished from other
// symbols by putting them between single quotes ('P').
// A string is a sequence of characters. A string is noted by surrounding 
// a group of letters with double quotes ("Processing").
// Chars and strings are most often used with the keyboard methods, 
// to display text to the screen, and to load images or files.

// Created 19 January 2003

BImage frog;
BFont fontA;
int xoffset;
char letter;
float scaleVal = 10.0;

void setup() 
{
  size(200, 200);
  fontA = loadFont("Univers55.vlw.gz"); 
  textFont(fontA); 
  
  // The String datatype must be capitalized because it is a complex datatype.
  // A String is actually a class with its own methods, some of which are
  // featured below.
  String name= "rathausFrog";
  String extension = ".jpg";
  int nameLength = name.length();
  println("The length of " + name + " is " + nameLength + ".");
  name = name.concat(extension);
  nameLength = name.length();
  println("The length of " + name + " is " + nameLength + ".");

  // The parameter for the loadImage() method must be a string
  // This line could also be written "frog = loadImage("rathausFrog.jpg");
  frog = loadImage(name);
}

void loop() 
{
  background(51); // Set background to dark gray
  
  push();
  translate(xoffset, 0, 0);
  image(frog, 0, 0);
  pop();
  
  // Get the width of the letter
  int letterWidth = int(fontA.width(letter)/2);
  
  // Move the letter to the center of the screen,
  // scale the letter, and then draw
  push();
  translate(width/2-(letterWidth*scaleVal), height/2, 0);
  scale(scaleVal);
  text(letter, 0, 0);
  pop();
  
  // Draw an X
  line(0, 0, width, height);  
  line(0, height, width, 0); 
}

void keyPressed()
{
  // The variable "key" always contains the value of the most recent key pressed.
  // If the key is an upper or lowercase letter between 'A' and 'z'
  // the image is shifted to the corresponding value of that key
  if(key >= 'A' && key <= 'z') {
    letter = char(key);
    // Scale the values to numbers between 0 and 100
    float scale = 100.0/57.0;
    int temp = int((key - 'A') * scale);
    // Set the offset for the image
    xoffset = temp;
    println(key);
  }
}




